-- name: [CS] Garfield
-- description: Garfield. Made by MiiMario64.
-- description: Garfield is an American comic created by Jim Davis. \n\nMade by MiiMario64. \n\nRequires Character Select!


local E_MODEL_GARFIELD = smlua_model_util_get_id("Garfield_geo")

local TEXT_MOD_NAME = "Garfield"

local TEX_GARFIELD = get_texture_info("Garfield_icon")

local VOICETABLE_GARFIELD = {
    [CHAR_SOUND_ATTACKED] = {'Garfield-ow.mp3', 'Garfield-uuurgh.mp3'},
    [CHAR_SOUND_COUGHING1] = 'Garfield-cough.mp3',
    [CHAR_SOUND_COUGHING2] = 'Garfield-cough-2.mp3',
    [CHAR_SOUND_COUGHING3] = 'Garfield-cough-3.mp3',
    [CHAR_SOUND_DOH] = 'Garfield-oof.mp3',
    [CHAR_SOUND_DROWNING] = 'Garfield-drowning.mp3',
    [CHAR_SOUND_DYING] = 'Garfield-dying.mp3',
    [CHAR_SOUND_EEUH] = 'Garfield-eeyuh.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Garfield-wuh.mp3',
    [CHAR_SOUND_HAHA] = {'Garfield-haha2.mp3', 'Garfield-haha2.mp3'},
    [CHAR_SOUND_HAHA_2] = {'Garfield-haha2.mp3','Garfield-haha2.mp3'},
    [CHAR_SOUND_HELLO] = 'Garfield-hey.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'Garfield-here-we-go.mp3',
    [CHAR_SOUND_HOOHOO] = 'Garfield-hah2.mp3',
    [CHAR_SOUND_HRMM] = 'Garfield-wuh.mp3',
    [CHAR_SOUND_IMA_TIRED] = 'silence.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Garfield-ok.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'Garfield-aw-man.mp3',
    [CHAR_SOUND_ON_FIRE] = 'Garfield-burning.mp3',
    [CHAR_SOUND_OOOF] = 'Garfield-ow2.mp3',
    [CHAR_SOUND_OOOF2] = 'Garfield-ow2.mp3',
    [CHAR_SOUND_PANTING] = {'Garfield-huff.mp3', 'Garfield-huff-2.mp3'},
    [CHAR_SOUND_PUNCH_HOO] = 'Garfield-yah.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'Garfield-hup.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'Garfield-hah.mp3',
    [CHAR_SOUND_SNORING1] = 'Garfield-snore.mp3',
    [CHAR_SOUND_SNORING2] = 'Garfield-snore-2.mp3',
    [CHAR_SOUND_SNORING3] = {'Garfield-snore-3.mp3', 'Garfield-snore-2.mp3'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Garfield-so-long-sucker.mp3',
    [CHAR_SOUND_UH] = 'Garfield-oof-low-energy.mp3',
    [CHAR_SOUND_UH2] = 'Garfield-oof-low-energy.mp3',
    [CHAR_SOUND_UH2_2] = 'Garfield-oof-low-energy.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'Garfield-scream.mp3',
    [CHAR_SOUND_WAH2] = 'Garfield-wuh.mp3',
    [CHAR_SOUND_WHOA] = 'Garfield-woah.mp3',
    [CHAR_SOUND_YAHOO] = 'Garfield-woohoo.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Garfield-woohoo.mp3', 'Garfield-aw-yeah.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'Garfield-hup.mp3', 'Garfield-wuh.mp3', 'Garfield-hah.mp3'},
    [CHAR_SOUND_YAWNING] = 'silence.ogg'
}

local PALLETE_GARFIELD = {
    [PANTS]  = {r = 0x60, g = 0x64, b = 0x64},
    [SHIRT]  = {r = 0xf7, g = 0xef, b = 0xb1},
    [GLOVES] = {r = 0xff, g = 0xff, b = 0xff},
    [SHOES]  = {r = 0x68, g = 0x40, b = 0x1b},
    [HAIR]   = {r = 0x73, g = 0x06, b = 0x00},
    [SKIN]   = {r = 0xfe, g = 0xd5, b = 0xa1},
    [CAP]    = {r = 0x76, g = 0xb4, b = 0xce},
    }


-- add it
if _G.charSelectExists then
    _G.charSelect.character_add("Garfield", {"Garfield is an American comic created by Jim Davis."}, "MiiMario64", {r = 240, g = 141, b = 27}, E_MODEL_GARFIELD, CT_MARIO, TEX_GARFIELD)

    _G.charSelect.character_add_voice(E_MODEL_GARFIELD, VOICETABLE_GARFIELD)

    --taken from toadette code

    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GARFIELD then return _G.charSelect.voice.sound(m, sound) end
    end)

    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GARFIELD then return _G.charSelect.voice.snore(m) end
    end)

    _G.charSelect.character_add_palette_preset(E_MODEL_GARFIELD, PALLETE_GARFIELD)

else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


